﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.Reflection;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript.Models;
using System.Runtime.Serialization;
using Syncfusion.JavaScript.Shared.Serializer;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using Syncfusion.Linq;
using System.Runtime.InteropServices;
using Newtonsoft.Json;
using System.Web.Script.Serialization;

public enum City
{
    [EnumMember(Value = "Berlin")]
    Berlin,
    [EnumMember(Value = "Mexico")]
    Mexico,
    [EnumMember(Value = "Colchester")]
    Colchester,
    [EnumMember(Value = "Lulea")]
    Lulea,
    [EnumMember(Value = "Mannheim")]
    Mannheim
};
namespace EnumProj.Controllers
{

    public class HomeController : Controller
    {
        
        
        public ActionResult Index()
        {
            return View();
        }
        public ActionResult Logs(DataManager dm)
        {
            if (dm.Where != null && dm.Where.Count != 0)
            {
                for (var val = 0; val < dm.Where.Count; val++)
                {
                    if (dm.Where[val].Field == "Country")
                        dm.Where[val].value = (City)Enum.Parse(typeof(City), dm.Where[val].value.ToString(), true);
                }
            }
            DataResult result = new DataResult();
            DataOperations opt = new DataOperations();
            IEnumerable datasource = GetInversedData().ToList();
            var dataResult = opt.Execute(datasource, dm);
            return Json(new DataResult() { result = dataResult, count = datasource.AsQueryable().Count() });
        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
        }
        public static List<Details> GetInversedData()
        {
            List<Details> obj = new List<Details>();
            for (var i = 0; i < 1; i++)
            {
                obj.Add(new Details() { EmployeeID = 10001, Date = new DateTime(2010, 1, 1), FirstName = "Nancy", LastName = "Davolio", Title = "Sales Representative", Country = City.Berlin });
                obj.Add(new Details() { EmployeeID = 10002, Date=new DateTime(2011, 1, 12), FirstName = "Andrew", LastName = "Fuller", Title = "Vice President, Sales" , Country = City.Mexico  });
                obj.Add(new Details() { EmployeeID = 10003, Date=new DateTime(2012, 1, 3), FirstName = "Janet", LastName = "Leverling", Title = "Sales Representative" , Country = City.Lulea  });
                obj.Add(new Details() { EmployeeID = 10004, Date=new DateTime(2013, 1, 14), FirstName = "Margaret", LastName = "Peacock", Title = "Sales Representative" , Country = City.Mexico });
                obj.Add(new Details() { EmployeeID = 10005, Date=new DateTime(2014, 1, 5), FirstName = "Steven", LastName = "Buchanan", Title = "Sales Manager" , Country = City.Mannheim });    
                obj.Add(new Details() { EmployeeID = 10006, Date=new DateTime(2015, 1, 6), FirstName = "Michael", LastName = "Suyama", Title = "Sales Representative" , Country = City.Berlin });     
                obj.Add(new Details() { EmployeeID = 10007, Date=new DateTime(2016, 1, 13), FirstName = "Robert", LastName = "King", Title = "Sales Representative" , Country = City.Mexico });
                obj.Add(new Details() { EmployeeID = 10008, Date=new DateTime(2017, 1, 1), FirstName = "Laura", LastName = "Callahan", Title = "Inside Sales Coordinator", Country = City.Mannheim });     
                obj.Add(new Details() { EmployeeID = 10009, Date=new DateTime(2018, 1, 8), FirstName = "Anne", LastName = "Dodsworth", Title = "Sales Representative", Country = City.Lulea });
                obj.Add(new Details() { EmployeeID = 10010, Date=new DateTime(2019, 1, 11), FirstName = "John", LastName = "Michel", Title = "Sales Manager" , Country = City.Berlin });
            }                                                                             
            return obj;
        }
        protected override JsonResult Json(object data, string contentType, System.Text.Encoding contentEncoding, JsonRequestBehavior behavior)
        {
            return new JsonNetResult
            {
                Data = data,
                ContentType = contentType,
                ContentEncoding = contentEncoding,
                JsonRequestBehavior = behavior
            };
        }
    }
    public class Details
    {
        public int EmployeeID{ get ; set ; }
        public DateTime Date { get; set; }
        public string FirstName { get; set; }
        public string LastName { get; set; }
        public string Title { get; set; }
        [Newtonsoft.Json.JsonConverter(typeof(Newtonsoft.Json.Converters.StringEnumConverter))]
        public City Country { get; set; }
    }
    public class JsonNetResult : JsonResult
    {
        public JsonNetResult()
        {
            Settings = new JsonSerializerSettings
            {
                ReferenceLoopHandling = ReferenceLoopHandling.Error
            };
        }

        public JsonSerializerSettings Settings { get; private set; }

        public override void ExecuteResult(ControllerContext context)
        {
            if (context == null)
                throw new ArgumentNullException("context");

            HttpResponseBase response = context.HttpContext.Response;

            if (this.ContentEncoding != null)
                response.ContentEncoding = this.ContentEncoding;
            if (this.Data == null)
                return;

            response.ContentType = string.IsNullOrEmpty(this.ContentType) ? "application/json" : this.ContentType;
            new Newtonsoft.Json.JsonSerializer().Serialize(response.Output, this.Data);
        }
    }

}